/* global BDF,$$,URLSearchParams */
/**
 * Objet global définissant l'espace de nom Multi
 * 
 * @namespace Multi
 */
var Multi = {};

Multi.ARGS = {
    authentificationSharingAllowed: false
};
Multi.waitingProcess = null;
Multi.fichothequeArray;
Multi.defaultLogin = "";

Multi.ping = function (requestParameters, pingCallback) {
    var ajaxData = {};
    if (requestParameters) {
        Object.assign(ajaxData, requestParameters);
    }
    ajaxData.json = "ping";
    $.ajax({
        url: BDF.URL,
        method: "GET",
        dataType: "json",
        data: ajaxData,
        xhrFields: {
           withCredentials: true
        },
        success: function (data, textStatus) {
            if (pingCallback) {
                pingCallback(data);
            }
        }
    });
};

Multi.initPanes = function () {
    $$("layout_list").html(BDF.render("multi:list-pane", {withSphereActions: Multi.ARGS.authentificationSharingAllowed}));
    BDF.runSerialFunctions(
       Multi.List.init
   );
   $$("listpane_button_newfichotheque").click(Multi.Overlay.showCreationForm);
   $$("listpane_button_initall").click(Multi.List.initAll);
   $$("listpane_button_listreload").click(Multi.List.reload);
   $$("listpane_button_personmanager").click(Multi.PersonManager.load);
};

Multi.testAuthentification = function (data) {
    if (!data.authentified) {
        $$("layout_main").html("");
        Multi.waitingProcess = Multi.initPanes;
        Multi.Overlay.showAuthentification(data);
        return false;
    } else {
        return true;
    }
};

BDF.addTemplateOptions({
    helpers: {
        isDefaultIncludeItems: function (key) {
            if (key.indexOf("thesaurus_") === 0) {
                return true;
            }
            if (key.indexOf("sphere_") === 0) {
                return true;
            }
            return false;
        }
    }
});

$(function(){
    if (URLSearchParams) {
        var searchParams = new URLSearchParams(window.location.search);
        if (searchParams.has("login")) {
            Multi.defaultLogin = searchParams.get("login");
        }
    }
    BDF.initTemplates();
    BDF.Pane.initLayout();
    BDF.initBeforeUnload();
    Multi.ping({}, function (data) {
        if (!data.authentified) {
            Multi.waitingProcess = Multi.initPanes;
            Multi.Overlay.showAuthentification(data);
        } else {
            Multi.initPanes();
        }
     });

});
